package com.sa.ibiz.demo.demo.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonProperty.Access;
import lombok.Data;
import org.springframework.beans.BeanUtils;
import org.springframework.cglib.beans.BeanMap;
import org.springframework.cglib.beans.BeanGenerator;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.FieldFill;
import java.util.Map;
import java.util.HashMap;
import org.springframework.util.StringUtils;
import com.sa.ibiz.demo.ibizutil.security.AuthenticationUser;
import java.util.Date;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.Size;
import org.springframework.util.DigestUtils;
import org.springframework.util.StringUtils;
import java.util.UUID;
import javax.validation.constraints.NotNull;
import java.io.Serializable;
import org.springframework.cglib.beans.BeanCopier;
import com.sa.ibiz.demo.ibizutil.annotation.Dict;
import com.sa.ibiz.demo.ibizutil.domain.EntityBase;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.IdWorker;
import java.math.BigInteger;
import com.sa.ibiz.demo.ibizutil.enums.FillMode;
import com.sa.ibiz.demo.ibizutil.enums.PredefinedType;
import com.sa.ibiz.demo.ibizutil.annotation.PreField;
import com.alibaba.fastjson.annotation.JSONField;

import com.sa.ibiz.demo.demo.domain.WFUser;
import com.sa.ibiz.demo.demo.domain.WFUser;

/**
 * 实体[WFUCPolicy] 数据对象
 */
@TableName(value = "T_SRFWFUCPOLICY",resultMap = "WFUCPolicyResultMap")
@JsonIgnoreProperties(ignoreUnknown = true)
@Data
public class WFUCPolicy extends EntityBase implements Serializable{

    @JSONField(serialize = false)
    @JsonIgnore
    @TableField(exist = false)//关系主表数据
    private WFUser majorwfuser;
    @JSONField(serialize = false)
    @JsonIgnore
    @TableField(exist = false)//关系主表数据
    private WFUser minorwfuser;
    private Timestamp begintime;
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEDATE)
    private Timestamp createdate;
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEMAN)
    @Dict(dictName = "ionicdemo_SysOperatorCodeList")
    private String createman;
    private Timestamp endtime;
    private String majorwfuserid;
    @TableField(exist = false)//逻辑属性
    private String majorwfusername;
    private String memo;
    private String minorwfuserid;
    @TableField(exist = false)//逻辑属性
    private String minorwfusername;
    @Dict(dictName = "ionicdemo_WFUCPolicyStateCodeList")
    private Integer policystate;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEDATE)
    private Timestamp updatedate;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEMAN)
    @Dict(dictName = "ionicdemo_SysOperatorCodeList")
    private String updateman;
    private String userdata;
    private String userdata2;
    @Dict(dictName = "ionicdemo_YesNoCodeList")
    private Integer validflag;
    @TableId(value= "wfucpolicyid",type=IdType.UUID)//指定主键生成策略
    private String wfucpolicyid;
    private String wfucpolicyname;
    /**
     *  设置属性值[开始时间]
     *  @param begintime
     */
    public void setBegintime(Timestamp begintime){
        this.begintime = begintime;
        this.set("begintimedirtyflag",true);
    }
    /**
     *  获取属性值[开始时间]
     */
    public Timestamp getBegintime(){
        return this.begintime;
    }
    /**
     *  重置属性值[开始时间]
     */
    public void resetBegintime(){
        this.set("begintimedirtyflag",false);
        this.begintime = null;
    }
    /**
     *  设置属性值[建立时间]
     *  @param createdate
     */
    public void setCreatedate(Timestamp createdate){
        this.createdate = createdate;
        this.set("createdatedirtyflag",true);
    }
    /**
     *  获取属性值[建立时间]
     */
    public Timestamp getCreatedate(){
        return this.createdate;
    }
    /**
     *  重置属性值[建立时间]
     */
    public void resetCreatedate(){
        this.set("createdatedirtyflag",false);
        this.createdate = null;
    }
    /**
     *  设置属性值[建立人]
     *  @param createman
     */
    public void setCreateman(String createman){
        if(StringUtils.isEmpty(createman))
            createman=null;
        this.createman = createman;
        this.set("createmandirtyflag",true);
    }
    /**
     *  获取属性值[建立人]
     */
    public String getCreateman(){
        return this.createman;
    }
    /**
     *  重置属性值[建立人]
     */
    public void resetCreateman(){
        this.set("createmandirtyflag",false);
        this.createman = null;
    }
    /**
     *  设置属性值[结束时间]
     *  @param endtime
     */
    public void setEndtime(Timestamp endtime){
        this.endtime = endtime;
        this.set("endtimedirtyflag",true);
    }
    /**
     *  获取属性值[结束时间]
     */
    public Timestamp getEndtime(){
        return this.endtime;
    }
    /**
     *  重置属性值[结束时间]
     */
    public void resetEndtime(){
        this.set("endtimedirtyflag",false);
        this.endtime = null;
    }
    /**
     *  设置属性值[工作流用户]
     *  @param majorwfuserid
     */
    public void setMajorwfuserid(String majorwfuserid){
        if(StringUtils.isEmpty(majorwfuserid))
            majorwfuserid=null;
        this.majorwfuserid = majorwfuserid;
        this.set("majorwfuseriddirtyflag",true);
    }
    /**
     *  获取属性值[工作流用户]
     */
    public String getMajorwfuserid(){
        return this.majorwfuserid;
    }
    /**
     *  重置属性值[工作流用户]
     */
    public void resetMajorwfuserid(){
        this.set("majorwfuseriddirtyflag",false);
        this.majorwfuserid = null;
    }
    /**
     *  设置属性值[工作流用户]
     *  @param majorwfusername
     */
    public void setMajorwfusername(String majorwfusername){
        if(StringUtils.isEmpty(majorwfusername))
            majorwfusername=null;
        this.majorwfusername = majorwfusername;
        this.set("majorwfusernamedirtyflag",true);
    }
    /**
     *  获取属性值[工作流用户]
     */
    public String getMajorwfusername(){
        return this.majorwfusername;
    }
    /**
     *  重置属性值[工作流用户]
     */
    public void resetMajorwfusername(){
        this.set("majorwfusernamedirtyflag",false);
        this.majorwfusername = null;
    }
    /**
     *  设置属性值[备注]
     *  @param memo
     */
    public void setMemo(String memo){
        if(StringUtils.isEmpty(memo))
            memo=null;
        this.memo = memo;
        this.set("memodirtyflag",true);
    }
    /**
     *  获取属性值[备注]
     */
    public String getMemo(){
        return this.memo;
    }
    /**
     *  重置属性值[备注]
     */
    public void resetMemo(){
        this.set("memodirtyflag",false);
        this.memo = null;
    }
    /**
     *  设置属性值[候选用户]
     *  @param minorwfuserid
     */
    public void setMinorwfuserid(String minorwfuserid){
        if(StringUtils.isEmpty(minorwfuserid))
            minorwfuserid=null;
        this.minorwfuserid = minorwfuserid;
        this.set("minorwfuseriddirtyflag",true);
    }
    /**
     *  获取属性值[候选用户]
     */
    public String getMinorwfuserid(){
        return this.minorwfuserid;
    }
    /**
     *  重置属性值[候选用户]
     */
    public void resetMinorwfuserid(){
        this.set("minorwfuseriddirtyflag",false);
        this.minorwfuserid = null;
    }
    /**
     *  设置属性值[候选用户]
     *  @param minorwfusername
     */
    public void setMinorwfusername(String minorwfusername){
        if(StringUtils.isEmpty(minorwfusername))
            minorwfusername=null;
        this.minorwfusername = minorwfusername;
        this.set("minorwfusernamedirtyflag",true);
    }
    /**
     *  获取属性值[候选用户]
     */
    public String getMinorwfusername(){
        return this.minorwfusername;
    }
    /**
     *  重置属性值[候选用户]
     */
    public void resetMinorwfusername(){
        this.set("minorwfusernamedirtyflag",false);
        this.minorwfusername = null;
    }
    /**
     *  设置属性值[策略状态]
     *  @param policystate
     */
    public void setPolicystate(Integer policystate){
        this.policystate = policystate;
        this.set("policystatedirtyflag",true);
    }
    /**
     *  获取属性值[策略状态]
     */
    public Integer getPolicystate(){
        return this.policystate;
    }
    /**
     *  重置属性值[策略状态]
     */
    public void resetPolicystate(){
        this.set("policystatedirtyflag",false);
        this.policystate = null;
    }
    /**
     *  设置属性值[更新时间]
     *  @param updatedate
     */
    public void setUpdatedate(Timestamp updatedate){
        this.updatedate = updatedate;
        this.set("updatedatedirtyflag",true);
    }
    /**
     *  获取属性值[更新时间]
     */
    public Timestamp getUpdatedate(){
        return this.updatedate;
    }
    /**
     *  重置属性值[更新时间]
     */
    public void resetUpdatedate(){
        this.set("updatedatedirtyflag",false);
        this.updatedate = null;
    }
    /**
     *  设置属性值[更新人]
     *  @param updateman
     */
    public void setUpdateman(String updateman){
        if(StringUtils.isEmpty(updateman))
            updateman=null;
        this.updateman = updateman;
        this.set("updatemandirtyflag",true);
    }
    /**
     *  获取属性值[更新人]
     */
    public String getUpdateman(){
        return this.updateman;
    }
    /**
     *  重置属性值[更新人]
     */
    public void resetUpdateman(){
        this.set("updatemandirtyflag",false);
        this.updateman = null;
    }
    /**
     *  设置属性值[用户数据]
     *  @param userdata
     */
    public void setUserdata(String userdata){
        if(StringUtils.isEmpty(userdata))
            userdata=null;
        this.userdata = userdata;
        this.set("userdatadirtyflag",true);
    }
    /**
     *  获取属性值[用户数据]
     */
    public String getUserdata(){
        return this.userdata;
    }
    /**
     *  重置属性值[用户数据]
     */
    public void resetUserdata(){
        this.set("userdatadirtyflag",false);
        this.userdata = null;
    }
    /**
     *  设置属性值[用户数据2]
     *  @param userdata2
     */
    public void setUserdata2(String userdata2){
        if(StringUtils.isEmpty(userdata2))
            userdata2=null;
        this.userdata2 = userdata2;
        this.set("userdata2dirtyflag",true);
    }
    /**
     *  获取属性值[用户数据2]
     */
    public String getUserdata2(){
        return this.userdata2;
    }
    /**
     *  重置属性值[用户数据2]
     */
    public void resetUserdata2(){
        this.set("userdata2dirtyflag",false);
        this.userdata2 = null;
    }
    /**
     *  设置属性值[是否启用]
     *  @param validflag
     */
    public void setValidflag(Integer validflag){
        this.validflag = validflag;
        this.set("validflagdirtyflag",true);
    }
    /**
     *  获取属性值[是否启用]
     */
    public Integer getValidflag(){
        return this.validflag;
    }
    /**
     *  重置属性值[是否启用]
     */
    public void resetValidflag(){
        this.set("validflagdirtyflag",false);
        this.validflag = null;
    }
    /**
     *  设置属性值[工作流候选用户策略标识]
     *  @param wfucpolicyid
     */
    public void setWfucpolicyid(String wfucpolicyid){
        if(StringUtils.isEmpty(wfucpolicyid))
            wfucpolicyid=null;
        this.wfucpolicyid = wfucpolicyid;
        this.set("wfucpolicyiddirtyflag",true);
    }
    /**
     *  获取属性值[工作流候选用户策略标识]
     */
    public String getWfucpolicyid(){
        return this.wfucpolicyid;
    }
    /**
     *  重置属性值[工作流候选用户策略标识]
     */
    public void resetWfucpolicyid(){
        this.set("wfucpolicyiddirtyflag",false);
        this.wfucpolicyid = null;
    }
    /**
     *  设置属性值[工作流候选用户策略名称]
     *  @param wfucpolicyname
     */
    public void setWfucpolicyname(String wfucpolicyname){
        if(StringUtils.isEmpty(wfucpolicyname))
            wfucpolicyname=null;
        this.wfucpolicyname = wfucpolicyname;
        this.set("wfucpolicynamedirtyflag",true);
    }
    /**
     *  获取属性值[工作流候选用户策略名称]
     */
    public String getWfucpolicyname(){
        return this.wfucpolicyname;
    }
    /**
     *  重置属性值[工作流候选用户策略名称]
     */
    public void resetWfucpolicyname(){
        this.set("wfucpolicynamedirtyflag",false);
        this.wfucpolicyname = null;
    }
     /**
     *  获取主实体关联数据[WFUser]
     */
    public WFUser getMajorwfuser() {
        return majorwfuser;
    }
    /**
     *  设置主实体关联数据[WFUser]
     */
    public void setMajorwfuser(WFUser majorwfuser) {
        this.majorwfuser = majorwfuser;
    }

     /**
     *  获取主实体关联数据[WFUser]
     */
    public WFUser getMinorwfuser() {
        return minorwfuser;
    }
    /**
     *  设置主实体关联数据[WFUser]
     */
    public void setMinorwfuser(WFUser minorwfuser) {
        this.minorwfuser = minorwfuser;
    }

    /**
     * 重置当前数据对象属性值
     */
    public  void reset(){
        resetBegintime();
        resetCreatedate();
        resetCreateman();
        resetEndtime();
        resetMajorwfuserid();
        resetMajorwfusername();
        resetMemo();
        resetMinorwfuserid();
        resetMinorwfusername();
        resetPolicystate();
        resetUpdatedate();
        resetUpdateman();
        resetUserdata();
        resetUserdata2();
        resetValidflag();
        resetWfucpolicyid();
        resetWfucpolicyname();
    }
     /**
     * 获取数据主键（普通主键与联合主键）
     * @return
     */
    @JsonIgnore
    public Serializable getDefaultPrimaryKey()
    {
	    //随机生成主键
         return  IdWorker.get32UUID();

    }
     /**
     * 复制当前对象数据到目标对象(粘贴重置)
     *
     * @throws Exception
     */
    public WFUCPolicy copyTo(WFUCPolicy targetEntity)
	{
		BeanCopier copier=BeanCopier.create(WFUCPolicy.class, WFUCPolicy.class, false);
		copier.copy(this, targetEntity, null);
        targetEntity.resetWfucpolicyid();
		return targetEntity;
	}
}